#!/usr/bin/perl
# $
# $	(Guestbook version 4.8)
# $
# $	Thank you for using my guestbook script, this has been popular with the web community
# $	and I have noticed many people using it on the internet, especially 2 sites that I
# $	know of that have been offering use of it for free.  This means a lot to me because
# $	they have chosen it over the many other guestbook scripts out there.
# $
# $	This code is distributed in the hope that is will be useful but WITHOUT ANY
# $	WARRANTY. ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY DISCLAMED. This includes
# $	but isn't limited to warranties of MERCHANTABILITY or FITNESS FOR A PARTICULAR
# $	PURPOSE.  The RESELLING of this code is STRICTLY PROHIBITED.
# $
# $	$Revision: 4.8
# $	$Author: Paul Williams
# $	$Email: paul@rainbow.nwnet.co.uk
# $	$URL: http://www.cougasoft.org/
# $	$Created: 05/07/1996 17:16
# $	$Last Modified: 01/04/2000 18:16
# $
# $	Copyright 1996, 1997, 1998, 1999, 2000 Cougasoft.  All rights reserved.
# $


	# $ If you have forgotten your password uncomment the variable below, then you
	# $ must immediately run administration (because it will be open for others to update)
	# $ Once you fill in the information you must comment this out again !
	# $FORGOTPASSWORD = 1;

	# $ I have noticed on the SunOS that perl can sometimes not locate the presence
	# $ of sendmail (could be like this on other Os's but..) if set to 0 or commented
	# $ out, the program will not check the existence of sendmail.
	$CHECK_MAILPROG = 1;

#
# $--------------------------------------------------------------------------------------------
#
#  M  A  I  N	  P  R	O  G  R  A  M
#
# $--------------------------------------------------------------------------------------------
#

	$VERSION = sprintf("%d.%02d", q$Revision: 4.61 $ =~ /(\d+)\.(\d+)/);


	unless ( (my $pref = &preferences("data/igb-pref.pref", 34) ) == 1
		|| (my $pref2 = &preferences("igb-pref.pref", 34) ) == 1)
	{
		print "Content-type: text/plain\n\n";
		print "Error initiating preference file(s);\n\n";
		print "$pref\n$pref2\n\nScript currently residing in:" . (`pwd`);
		exit;
	}

  	my (%INPUT, %PREF, %ERR, $FLAGPOST, $FLAGFORMPRINT, $cgiopt, $cgicount, $cgierr, @manchester);
	&ReadInput();

#
# $--------------------------------------------------------------------------------------------
#
#  S  T  A  T  U  S    C  H  E	C  K
#
# $--------------------------------------------------------------------------------------------
#

  	# $ If the administrator is coming to the guestbook for the first time, certain variables
	# $ will be incorrect therefore we must ascertain which is wrong and tell them !
	if ($FORGOTPASSWORD or !$PREF{'USERNAME'} or !$PREF{'PASSWORD'} or !-e "$PREF{'DATA'}"
		or ($CHECK_MAILPROG && !-e "$PREF{'MAILPGRM'}") or !-e "$PREF{'PREFERENCE'}")
	{

		# $ If we have read some data from STDIN and there are no errors (plus
		# $ a couple of simple error checks) we can add the data to the pref file).
		if ($FLAGPOST && !$cgierr && $cgicount == 4 && $ENV{'HTTP_REFERER'} =~ /^http:\/\/$ENV{'HTTP_HOST'}$ENV{'SCRIPT_NAME'}/ )
		{
	      		# To speed up admin pref updates we get its true location of it (-e existance)
			$PREF{'DATA'}	    = $INPUT{'DATA'};
			$PREF{'MAILPGRM'}   = $INPUT{'MAILPGRM'};
			$PREF{'USERNAME'}   = $INPUT{'USERNAME'};
			$PREF{'PASSWORD'}   = crypt($INPUT{'PASSWORD'}, AD);
			$PREF{'PREFERENCE'} = "igb-pref.pref" if (-e 'igb-pref.pref');
			$PREF{'PREFERENCE'} = "data/igb-pref.pref" if (-e 'data/igb-pref.pref');

			&write_preferences();

	      		# Success screen, when I finally finish the scripts (even thought this is supposed
	      		# to be the final release ;) I will improve the html etc... and get it looking pretty
	      		&notify("Success !", "[Variables have sucessfully been added]<BR><BR>You may now enter " .
			   "administration <A HREF=\"$ENV{'SCRIPT_NAME'}?action=reprincipo\">h e r e</A>." .
			   ($FORGOTPASSWORD ? "<BR>Also, set \$FORGOTPASSWORD to zero before clicking !" : ""), undef);
		}

	      	# $ Now we will try and verify the existence of the data file, if it doesn't
	      	# $ exist then the variable $linkxtra is inserted below the linkfile field
		$ERR{'DATA'} = "I am afraid that this file does not exist." unless -e $PREF{'DATA'};
		$ERR{'MAILPROG'} = "This does not point to sendmail" if $CHECK_MAILPROG and !$FLAGPOST and !-e $PREF{'MAILPGRM'};
		my $more = "<BR><CENTER><FONT SIZE=-1>\$preference variable was incorrect, please " .
		 	"resubmit variables to reset the bad variable</FONT></CENTER>" unless -e $PREF{'PREFERENCE'};

		&top_html("Setting Variables");
		&FormPrint("CELLSPACING=0 CELLPADDING=4 BORDER=0", 25, "q=mainstart", 1,
			HEADER, "SET PREFERENCES", "\n",
			TEXT, "Username", "_rwb[']l[5][20]_USERNAME", $FLAGPOST?$INPUT{'USERNAME'}:$PREF{'USERNAME'}, 25, 20, "\n",
			TEXT, "Password", "_rwb[']l[5][20]_PASSWORD", $INPUT{'PASSWORD'}, 25, 20, "\n",
			HEADER, "LOCATIONS", "\n",
			TEXT, "Link Data File", "_rt_DATA", $FLAGPOST?$INPUT{'DATA'}:$PREF{'DATA'}, 50, 255, "\n",
			TEXT, "Sendmail", "_r" . ($CHECK_MAILPROG ? "t" : "") . "_MAILPGRM", $FLAGPOST?$INPUT{'MAILPGRM'}:$PREF{'MAILPGRM'}, 50, 100, "\n",
		);
		print $more;
		&bottom(1);
	 }

#
# $--------------------------------------------------------------------------------------------
#
#  V  E R  I  F  Y  -  S  T  A	T  U  S
#
# $--------------------------------------------------------------------------------------------
#

	# $ User is entering administration, the function above have stored the information
  	# $ in hash variable %INPUT so we will just check the details against the preferences

  	if ($INPUT{'&q'} eq "emporio")
   	{
		if ((crypt($INPUT{'password'}, "AD") eq $PREF{'PASSWORD'}) && ($INPUT{'username'} eq $PREF{'USERNAME'}) && ($ENV{'HTTP_REFERER'} =~ /^http:\/\/$ENV{'HTTP_HOST'}$ENV{'SCRIPT_NAME'}/))
	 	{
			&top_html("Administration", 1);
			&bottom(1);
	 	}

		&notify("500 Internal Server Error", "You have entered incorrect info", 1);
   	}

#
# $--------------------------------------------------------------------------------------------
#
#  U  P  D  A  T  E  -	G  U  E  S  T  B  O  O	K
#
# $--------------------------------------------------------------------------------------------
#

	elsif ($INPUT{'&q'} eq "update-igb")
  	{
		&check_user();
		my $n;
		
		&top_html("Entries", 1);
	   	print "<P><FORM METHOD=POST ACTION=\"$ENV{'SCRIPT_NAME'}?q=updateentries+un=$PREF{'USERNAME'}+pw=$PREF{'PASSWORD'}\"></P>\n" .
			"<CENTER>\n" .
			"\n" .
			"<TABLE CELLSPACING=0 CELLPADDING=4 BGCOLOR=\"$PREF{'TBCOLOR'}\">\n" .
			"<TR BGCOLOR=\"$PREF{'RESHADE'}\">\n" .
			"\n" .
			"<TD><FONT SIZE=-1><B><FONT FACE=\"ARIAL\">No</B></FONT></TD>\n" .
			"<TD><FONT SIZE=-1><B><FONT FACE=\"ARIAL\">Posted by</FONT></TD>\n" .
			"<TD><FONT SIZE=-1><B><FONT FACE=\"ARIAL\">City</FONT></TD>\n" .
			"<TD><FONT SIZE=-1><B><FONT FACE=\"ARIAL\">Comment</FONT></TD>\n" .
			"<TD><FONT SIZE=-1><B><FONT FACE=\"ARIAL\">URL</FONT></TD>\n" .
			"<TD><FONT SIZE=-1><B><FONT FACE=\"ARIAL\">Delete</FONT></TD>\n" .
			"\n";
		print "</TR>\n";

		# Manchester array is built inside the &top_html() subroutine.
		foreach (@manchester)
	 	{
	     		my ($email, $name, $city, $state, $comment, $url, $date, $country) = split('\|\|');

			print "<TR>\n";
			print "\n";
			print "<TD><FONT SIZE=-1>" . ++$n . "</FONT></TD>\n";
			print "<TD><FONT SIZE=-1><A HREF=\"$ENV{'SCRIPT_NAME'}?q=reply+un=$PREF{'USERNAME'}+pw=$PREF{'PASSWORD'}+mailto=$email\">$name</A></FONT></TD>\n";
			print "<TD><FONT SIZE=-1>$city&nbsp;$country</TD>\n";
			print "<TD><FONT SIZE=-1>$comment &nbsp;</TD>\n";
			print "<TD ALIGN=CENTER><FONT SIZE=-1><A HREF=\"$url\">LINK</A></FONT></TD>\n" if $url;
			print "<TD ALIGN=CENTER><FONT SIZE=-1>-</FONT></TD>\n" if !$url;
			print "<TD ALIGN=CENTER><FONT SIZE=-1><INPUT type =\"CHECKBOX\" name=\"_p_DEL\" value=\"$date\"></TD>\n";
			print "\n";
			print "</TR>\n";
  	 	}

	   	print "<TR><TD BGCOLOR=\"$PREF{'RESHADE'}\" COLSPAN=6><FONT SIZE=-1><INPUT TYPE=\"SUBMIT\" VALUE=\"s u b m i t\"></FONT></TD>\n";
  	   	print "</FORM></TR></TABLE></CENTER>\n\n";

		&bottom(1);
  	}

#
# $--------------------------------------------------------------------------------------------
#
#  D  E  L  E  T  E    E  N  T	R  I  E  S
#
# $--------------------------------------------------------------------------------------------
#

 	elsif ($INPUT{'&q'} eq "updateentries")
  	{
		&check_user();
		&notify("501 Data Server Error", "You need to select a link to delete ;)", 1) unless @DEL;

#define SKIP_CODE
		my (@results, $del, $acount, $delete);
		&openf(DATABASE, "+>>$PREF{'DATA'}");

		# $ Get data and then wipe the file clean
		seek DATABASE, 0, 0; @results = <DATABASE>;
		seek DATABASE, 0, 0; truncate DATABASE, 0;

		foreach (@results)
	 	{
			my ($email, $name, $city, $state, $comment, $url, $date, $country) = split('\|\|');
		 	$del = 0;

			foreach $delete (@DEL) {
				if ($date eq $delete) {
				++$acount;
				$del = 1;
				last;
		    		}
			}

			print DATABASE unless ($del);
	 	}
		close(DATABASE);

		# $ If nothing has been deleted then this page is shown, just to inform
		&notify("Error !", "Sorry, no links for me to delete ;)", 1) unless ($acount);

		&top_html("Updated", 1);
		&nframe("Entr" . ($acount==1?"y":"ies") . " ha" .
			($acount==1?"s":"ve") . " sucessfully been deleted.");
		&bottom(1);
#define END_SKIP_CODE


  	}

#
# $--------------------------------------------------------------------------------------------
#
#  R  E  P  L  Y  -  S	I  G  N  A  T  O  R  I	E  S
#
# $--------------------------------------------------------------------------------------------
#

 	elsif ($INPUT{'&q'} eq "reply")
  	{
		&check_user();

		&top_html("Reply to the sender...", 1);
 	   	print "<CENTER><P>\n" .
	     		"<FORM METHOD=POST ACTION='$ENV{'SCRIPT_NAME'}?q=emailreply+un=$PREF{'USERNAME'}+pw=$PREF{'PASSWORD'}'>\n\n" .
	     		"<TABLE CELLSPACING=0 CELLPADDING=1 BGCOLOR='$INPUT{TBCOLOR}'>\n" .

	     		"<TR><TD BGCOLOR='$PREF{'RESHADE'}'><FONT SIZE=-1>Subject</FONT></TD>\n" .
	     		"<TD BGCOLOR=\"$PREF{'TBCOLOR'}\"><INPUT type='text' name='_r_SUBJECT' size='40' maxlength='250' VALUE='$PREF{'REPLYSUBJECT'}'></TD></TR>\n\n" .

	     		"<TR><TD BGCOLOR=\"$PREF{'RESHADE'}\"><FONT SIZE=-1>E-mail</FONT></TD>\n" .
	     		"<TD BGCOLOR=\"$PREF{'TBCOLOR'}\"><INPUT TYPE=text NAME='_re_EMAIL' size=40 value='$INPUT{'&mailto'}'></TD></TR>\n" .

	     		"<TR><TD BGCOLOR='$PREF{'RESHADE'}'><FONT SIZE=-1>Email Message</FONT></TD>\n" .
	     		"<TD BGCOLOR=\"$PREF{'TBCOLOR'}\"><TEXTAREA NAME='_r_MESSAGE' COLS='55' ROWS='7' WRAP=PHYSICAL></TEXTAREA></TD></TR>\n\n" .

	     		"<TR><TD COLSPAN=2 BGCOLOR='$PREF{'RESHADE'}'><FONT SIZE=-1><INPUT TYPE='submit' VALUE='s u b m i t'></FONT></TD></TR>\n\n";
	   	print "</TABLE></CENTER>\n";
		&bottom(1);
	}

#
# $--------------------------------------------------------------------------------------------
#
#  R  E  P  L  Y  -  E	M  A  I  L  _  R  E  P	L  Y
#
# $--------------------------------------------------------------------------------------------
#

 	elsif ($INPUT{'&q'} eq "emailreply")
  	{
		&check_user();

		# Strip away carriage returns (Sendmail takes care of it anyways)
		$INPUT{'MESSAGE'} =~ s/\cM//g;

		open(MAIL, "| $PREF{'MAILPGRM'} -t") or &notify("500 Internal Server Error", "I was not able to pipe to the sendmail program<BR>verify the location and try again<BR><BR>If this is not admin, please let him/her<BR> know about this problem.", 0);
			print MAIL "To: $INPUT{'EMAIL'}\n";
			print MAIL "From: $PREF{'YOURNAME'} <$PREF{'YOUREMAIL'}>\n";
			print MAIL "Subject: $INPUT{'SUBJECT'}\n";
			print MAIL "\n";
			print MAIL "$INPUT{'MESSAGE'}\n";
		close(MAIL);

		&top_html("Email sent !", 1);
		&nframe("Your reply has been sent to $INPUT{'EMAIL'}");
		&bottom(1);
	}

#
# $--------------------------------------------------------------------------------------------
#
#  E  M  A  I  L  -  P	R  E  F  E  R  E  N  C	E  S
#
# $--------------------------------------------------------------------------------------------
#

 	elsif ($INPUT{'&q'} eq "email-pref")
  	 {
     		&check_user();
     		$PREF{'MAIL'} =~ s/\\n/\n/g;
		sub helpid { my $one = $_[0]; return "<A HREF=\"$ENV{'SCRIPT_NAME'}?q=help+un=$PREF{'USERNAME'}+pw=$PREF{'PASSWORD'}+helpid=" . ($one=~tr, ,_,?$one:$one) . "\">" . ($_[0]) . "</A>"; }

		if ($FLAGPOST && !$cgierr && $cgicount >= 7 && $ENV{'HTTP_REFERER'} =~ /^http:\/\/$ENV{'HTTP_HOST'}$ENV{'SCRIPT_NAME'}/ )
		{
			$INPUT{'PASSWORD'} = crypt $INPUT{'PASSWORD'}, AD if $INPUT{'PASSWORD'};
			map defined $PREF{$_} ? ($PREF{$_} = $INPUT{$_}) : undef, keys %INPUT;
			$PREF{'MAIL'} =~ s,\cM\n,\\n,g;
			$PREF{'EMAIL_YOU'} = $INPUT{'EMAIL_YOU'} || 0;
			$PREF{'NOTIFY'} = $INPUT{'NOTIFY'} || 0;
#define SKIP_CODE
			&write_preferences();
#define END_SKIP_CODE

		     	if (!$INPUT{'PASSWORD'})
			{
			       &top_html('Sucess !', 1);
			       &nframe("Your preferences have now been set.");
			       &bottom(1);
			}
			else
			{
			       &notify('Preferences have been set.', "[Your preferences have now been set]<BR> " .
				  "Please click <A HREF=\"$ENV{'SCRIPT_NAME'}?q=reprincipo\">h e r e</A> to " .
				  "re-enter administration.", 0);
			}
		}

		&top_html("Email Preferences", 1);
		&FormPrint("CELLSPACING=0 CELLPADDING=4 WIDTH=\"\"", 25, "q=email-pref+un=$INPUT{'&un'}+pw=$INPUT{'&pw'}", 1,
			HEADER, "EMAIL&nbsp;PREF", "\n",
			TEXT, &helpid("Name"), "_r_YOURNAME", &Ternary($FLAGPOST?$INPUT{'YOURNAME'}:$PREF{'YOURNAME'}), 40, 200, "\n",
			TEXT, &helpid("Email Address"), "_re_YOUREMAIL", &Ternary($FLAGPOST?$INPUT{'YOUREMAIL'}:$PREF{'YOUREMAIL'}), 40, 255, "\n",
			CHECKBOX, &helpid("Email Thanks"), "EMAIL_YOU", 1, $FLAGPOST?$INPUT{'EMAIL_YOU'}:$PREF{'EMAIL_YOU'}, "Emails each signatory a defined email.", "\n",
			CHECKBOX, &helpid("Notify You"), "NOTIFY", 1, $FLAGPOST?$INPUT{'NOTIFY'}:$PREF{'NOTIFY'}, "You are emailed after each post.", "\n",
			TEXT, &helpid("Subject"), "_r_SUBJECT", &Ternary($FLAGPOST?$INPUT{'SUBJECT'}:$PREF{'SUBJECT'}), 40, 255, "\n",
			TEXTAREA, &helpid("Mail Them What")  . "<font face=arial size=-2><BR><BR>[<B>VARIABLE KEY</B>]<BR>%n = name<BR>%e = email address<BR>%u = link<BR>%c = comments<BR>%g = Guestbook URL<BR>%d = Date</FONT>", "_l[25][3000]_MAIL", &Ternary($FLAGPOST?$INPUT{'MAIL'}:$PREF{'MAIL'}), 55, 7, "\n",
			HEADER, "ADMIN&nbsp;REPLY&nbsp;OPTION", "\n",
			TEXT, &helpid("Default Subject"), "_r_REPLYSUBJECT", &Ternary($FLAGPOST?$INPUT{'REPLYSUBJECT'}:$PREF{'REPLYSUBJECT'}), 40, 255, "\n",
			HEADER, "USER PREF", "\n",
			TEXT, &helpid("Username"), "_rwl[5][20]_USERNAME", &Ternary($FLAGPOST?$INPUT{'USERNAME'}:$PREF{'USERNAME'}), 25, 20, "\n",
			PASSWORD, &helpid("Password"), "_wl[5][20]_PASSWORD", $INPUT{'PASSWORD'}, 25, 20, "\n",
		);
		&bottom(1);
 	 }

#
# $--------------------------------------------------------------------------------------------
#
#  L  A  Y  O  U  T  -	P  R  E  F  E  R  E  N	C  E  S
#
# $--------------------------------------------------------------------------------------------
#

 	elsif ($INPUT{'&q'} eq "layout-pref")
  	 {
		&check_user();

		if ($FLAGPOST && !$cgierr && $cgicount >= 19 && $ENV{'HTTP_REFERER'} =~ /^http:\/\/$ENV{'HTTP_HOST'}$ENV{'SCRIPT_NAME'}/ )
		{
			map defined $PREF{$_} ? ($PREF{$_} = $INPUT{$_}) : undef, keys %INPUT;

			$PREF{'FLOCK'} = $INPUT{'FLOCK'} || 0;
			$PREF{'CHECKBIGWORD'} = $INPUT{'CHECKBIGWORD'} || 0;
			$PREF{'DISALLOW'} = $INPUT{'DISALLOW'} || 0;
			$PREF{'HTML'} = $INPUT{'HTML'} || 0;
#define SKIP_CODE
			&write_preferences();
#define END_SKIP_CODE

			&top_html('Sucess !', 1);
			&nframe("Your preferences have now been set.");
			&bottom(1);
		}

		unless ($FLAGPOST)
		{
			$PREF{'ERR'} = $PREF{'BODYTEXT'};
			$ERR{'BACKGROUND'} = "Leave blank for no background graphic";
			$ERR{'TARGET'} = "Home, sign-book etc..";
			$ERR{'TARGET_URL'} = "Target for clicked links";
			$ERR{'RESHADE'} = "Leave blank for the script to decide";
			$ERR{'DISALLOWFILE'} = "Each word inside it should be separated by a new line.";
		}

		&top_html("Layout Preferences", 1);
		&FormPrint("CELLSPACING=0 CELLPADDING=4", 25, "q=layout-pref+un=$INPUT{'&un'}+pw=$INPUT{'&pw'}", 1,
			HEADER, "LAYOUT&nbsp;PREF", "\n",
			TEXT, &helpid("Guestbook Name"), "_r_GBNAME", &Ternary($FLAGPOST?$INPUT{'GBNAME'}:$PREF{'GBNAME'}), 20, 255, "\n",
			TEXT, &helpid("Your URL"), "_ru_HOME", &Ternary($FLAGPOST?$INPUT{'HOME'}:$PREF{'HOME'}), 40, 255, "\n",
			TEXT, &helpid("GIF"), "_ri_GIF", &Ternary($FLAGPOST?$INPUT{'GIF'}:$PREF{'GIF'}), 40, 255, "\n",
			TEXT, &helpid("Body Text"), "_rh_BODYTEXT", &Ternary($FLAGPOST?$INPUT{'BODYTEXT'}:$PREF{'BODYTEXT'}), 20, 7, "\n",
			TEXT, &helpid("Page Bgcolor"), "_rh_BGCOLOR", &Ternary($FLAGPOST?$INPUT{'BGCOLOR'}:$PREF{'BGCOLOR'}), 20, 7, "\n",
			TEXT, &helpid("Background GIF"), "_i_BACKGROUND", &Ternary($FLAGPOST?$INPUT{'BACKGROUND'}:$PREF{'BACKGROUND'}), 40, 255, "\n",
			TEXT, &helpid("Link"), "_rh_LINK", &Ternary($FLAGPOST?$INPUT{'LINK'}:$PREF{'LINK'}), 20, 7, "\n",
			TEXT, &helpid("Visited Link"), "_rh_VLINK", &Ternary($FLAGPOST?$INPUT{'VLINK'}:$PREF{'VLINK'}), 20, 7, "\n",
			TEXT, &helpid("Active Link"), "_rh_ALINK", &Ternary($FLAGPOST?$INPUT{'ALINK'}:$PREF{'ALINK'}), 20, 7, "\n",
			TEXT, &helpid("Table Bgcolor"), "_rh_TBCOLOR", &Ternary($FLAGPOST?$INPUT{'TBCOLOR'}:$PREF{'TBCOLOR'}), 20, 7, "\n",
			TEXT, &helpid("Table Reshade"), "_h_RESHADE", &Ternary($FLAGPOST?$INPUT{'RESHADE'}:$PREF{'RESHADE'}), 20, 7, "\n",
			SELECT, &helpid("Order"), "DISPLAY", &Ternary($FLAGPOST?$INPUT{'DISPLAY'}:$PREF{'DISPLAY'}), 
				"Most recent on top", 1,
				"Oldest on top", 2, "\n",
			SELECT, &helpid("Signing Amount"), "MAXIMUM", $FLAGPOST ? $INPUT{'MAXIMUM'} : $PREF{'MAXIMUM'},
				"10", 10, "20", 20, "30", 30, "40", 40, "50", 50, "60", 60,
				"70", 70, "80", 80, "90", 90, "100", 100, "\n",
			SELECT, &helpid("Per Page"), "PERPAGE", $FLAGPOST ? $INPUT{'PERPAGE'} : $PREF{'PERPAGE'},
				"10", 10, "20", 20, "30", 30, "40", 40, "50", 50, "60", 60,
				"70", 70, "80", 80, "90", 90, "100", 100, "\n",
			TEXT, &helpid("Target"), "TARGET", &Ternary($FLAGPOST?$INPUT{'TARGET'}:$PREF{'TARGET'}), 20, 255, "\n",
			TEXT, &helpid("URL Target"), "TARGET_URL", &Ternary($FLAGPOST?$INPUT{'TARGET_URL'}:$PREF{'TARGET_URL'}), 20, 255, "\n",
			HEADER, "DATA PREF", "\n",
			TEXT, &helpid("IGB Data File"), "_rt_DATA", &Ternary($FLAGPOST?$INPUT{'DATA'}:$PREF{'DATA'}), 40, 255, "\n",
			TEXT, &helpid("Mail program"), "_r" . ($CHECK_MAILPROG ? "t" : "") . "_MAILPGRM", $FLAGPOST?$INPUT{'MAILPGRM'}:$PREF{'MAILPGRM'}, 40, 100, "\n",
			HEADER, "USE FILE LOCKING", "\n",
			CHECKBOX, &helpid("Lock files?"), "FLOCK", 1, $FLAGPOST?$INPUT{'FLOCK'}:$PREF{'FLOCK'}, "Locks files to prevent corruption.", "\n",
			HEADER, "EXTRA OPTIONS", "\n",
			CHECKBOX, &helpid("Disallow HTML ?"), "HTML", 1, $FLAGPOST?$INPUT{'HTML'}:$PREF{'HTML'}, "If checked, html is stripped", "\n",
			CHECKBOX, &helpid("Check big words"), "CHECKBIGWORD", 1, $FLAGPOST?$INPUT{'CHECKBIGWORD'}:$PREF{'CHECKBIGWORD'}, "Ignores descriptive words over 30 characters.", "\n",
			TEXT, &helpid("How many words?"), "_rd_MAXWORDS", &Ternary($FLAGPOST?$INPUT{'MAXWORDS'}:$PREF{'MAXWORDS'}), 40, 255, "\n",
			HEADER, "DISALLOW WORDS", "\n",
			CHECKBOX, &helpid("Disallow certain words"), "DISALLOW", 1, $FLAGPOST?$INPUT{'DISALLOW'}:$PREF{'DISALLOW'}, "Path to file must be added below.", "\n",
			TEXT, &helpid("Disallow file"), "_rt_DISALLOWFILE", &Ternary($FLAGPOST?$INPUT{'DISALLOWFILE'}:$PREF{'DISALLOWFILE'}), 40, 255, "\n",
		);
  	}

#
# $--------------------------------------------------------------------------------------------
#
#  H  A  N  D  Y  -  H	E  L  P
#
# $--------------------------------------------------------------------------------------------
#

  	elsif ($INPUT{'&q'} eq "help")
	{
		&check_user();
		$INPUT{'&helpid'} =~ s/_/ /g;

		while (<DATA>)
		{
			if (/^$INPUT{'&helpid'}\:/i) {
				&top_html("Help: $INPUT{'&helpid'}", 1);
				&info("HELP: What is <I>$INPUT{'&helpid'}</I> ?", ($_ =~ s/^$INPUT{'&helpid'}\://i) ? $_ : "REGEXP FATAL ERROR", 1);
			}
		}

		&top_html("Help ID not found.", 1);
		&nframe("No help associated with that help ID.");
		&bottom(1);
	}

#
# $--------------------------------------------------------------------------------------------
#
#  D  E  F  A  U  L  T	-  C  O  D  E
#
# $--------------------------------------------------------------------------------------------
#

	else
   	{
		&top_html("Administration Area");
		   print "<BR><CENTER><TABLE CELLSPACING=0 CELLPADDING=0>\n" .
		       "<TR><TD><FORM METHOD=\"POST\" ACTION=\"$ENV{'SCRIPT_NAME'}?q=emporio\"></TD>\n" .
		       "<TD BGCOLOR=\"$PREF{'TBCOLOR'}\"><TT>&nbsp;Username&nbsp;\n</TT></TD>\n\n" .
		       "<TD><INPUT TYPE=\"text\" maxlength=\"8\" NAME=\"username\" VALUE=\"" .
		       "\"></TD></TR>\n" .
		       "<TR><TD></TD><TD BGCOLOR=\"$PREF{'TBCOLOR'}\"><TT>&nbsp;Password&nbsp;\n</TT></TD>\n\n" .
		       "<TD><INPUT TYPE=\"password\" maxlength=\"8\" NAME=\"password\" VALUE=\"" .
		       "\"></TD></TR>\n" .
		       "<TR><TD></TD><TD></TD>\n\n" .
		       "<TD>\n<INPUT TYPE=\"submit\" VALUE=\"  Submit  \"><INPUT TYPE=\"reset\" VALUE=\"   Reset  \">\n</FORM></TD>\n\n";
		   print "</TR></TABLE></CENTER>\n";
		&bottom(1);
   	}

#
# $--------------------------------------------------------------------------------------------
#
#  S  U  B  R  O  U  T  I N  E  S
#
# $--------------------------------------------------------------------------------------------
#

	sub top_html
   	{
		if ($_[1])
		{
			&openf(UNITED, "$PREF{'DATA'}");
	  			@manchester = <UNITED>;
	  			$c = @manchester;
		   	close(UNITED);
		}

		print "Content-type: text/html\n\n" .
		# $ Please don't change this, people seem to like to alter the written by which is
		# $ a little dis-heartening, especially as its hidden inside the html output. The
		# $ version number is also embedded in the script which helps me if ever you have
		# $ trouble with it.
		    "<!-- Inter Guestbook $VERSION Written by Paul Williams, Cougasoft [paul\@rainbow.nwnet.co.uk] -->\n" .
	    	    "<HTML>\n" .
	    	    "<HEAD>\n" .
	    	    "	 <TITLE>$PREF{'GBNAME'} Guestbook - $_[0]</TITLE>\n" .
	    	    "</HEAD>\n" .
	    	    "<BODY TEXT='$PREF{'BODYTEXT'}' BGCOLOR='$PREF{'BGCOLOR'}' LINK='$PREF{'LINK'}' VLINK='$PREF{'VLINK'}' ALINK='$PREF{'ALINK'}' BACKGROUND='$PREF{'BACKGROUND'}'>\n\n";
		print "<CENTER><IMG SRC='$PREF{'GIF'}'></CENTER>\n\n" if $PREF{GIF};

		print "<CENTER><FONT SIZE =-1> " .
	      	    "[<A HREF=\"$ENV{'SCRIPT_NAME'}?q=email-pref+un=$PREF{'USERNAME'}+pw=$PREF{'PASSWORD'}\">Email pref</A>] " .
		    "[<A HREF=\"$ENV{'SCRIPT_NAME'}?q=update-igb+un=$PREF{'USERNAME'}+pw=$PREF{'PASSWORD'}\">Update guestbook ($c)</A>] " .
		    "[<A HREF=\"$ENV{'SCRIPT_NAME'}?q=layout-pref+un=$PREF{'USERNAME'}+pw=$PREF{'PASSWORD'}\">Layout pref</A>] " .
		"</FONT></CENTER>" if $_[1];
   	}

#
# $--------------------------------------------------------------------------------------------
#
#  S  U  B  -  T  E  R	N  A  R  Y
#
# $--------------------------------------------------------------------------------------------
#

	sub Ternary
	{
		my $ternval = shift;
		$ternval =~ s,",&quot;,g;

		return $ternval ? $ternval : undef;
	}

#
# $--------------------------------------------------------------------------------------------
#
#  S  U  B  -  R  E  A	D  -  I  N  P U  T
#
# $--------------------------------------------------------------------------------------------
#

	sub ReadInput
	{
		my $choice = shift;

	 	if ($ENV{'QUERY_STRING'})
	  	{
			my (@pairs, $pair, $name, $value);

			@pairs = split($choice?'\&':'\+', $ENV{'QUERY_STRING'});

			foreach $pair (@pairs)
			{
				($name, $value) = split(/=/, $pair);

				$value =~ tr/+/ /;
				$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
				$INPUT{"&$name"} = $value;
			}
	  	}

		my (@pairs, $input, $pair, $name, $value, $opt);

		if ($ENV{'CONTENT_LENGTH'})
  		{
			read(STDIN, $input, $ENV{'CONTENT_LENGTH'});

			@pairs = split(/&/, $input);

			foreach $pair (@pairs)
			{
				($name, $value) = split(/=/, $pair);

				$name =~ tr/+/ /;
				$name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

				$value =~ tr/+/ /;
				$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    				$value =~ s/^\s*//; # Don't allow people to just use a space by
    				$value =~ s/\s*$//; # chopping all preceding and trailing spaces.

				# Check the $name key above for a little more information.
				if ($name =~ s/^_(.*?)_([A-Z\- ]+)$/$2/)
				{
					$opt = $1;

  					# $ Must do the substitution option now because it contains some
  					# $ flags which the others may need to work with (eg 'u').
  					if ($opt =~ /s\[([shutle]+)\]/)
					 {
					 	$_ = $1;
					 	if ($value)
					 	{
					 		$value =~ s/<([^>]|\n)*>//g if /h/;
					 		$value =~ s/\s+/ /g if /s/;
					 		$value =~ s/'/\\'/g if /e/; # Escape
					 		$value =~ s/\b(\w){1}(\w+)\b/(uc $1) . (lc $2)/ge if /t/;
					 		$value = uc $value if /u/;
					 		$value = lc $value if /l/;
					 	}

						# Remove all the sub flags from the option.
					 	$opt =~ s/s\[$_\]//;
					 }

					# $ B = banned/disallowed characters. $opt comes in the form
					# $ of a regular expression so make sure its right ;)
					if ($opt =~ /b\[(.*?)\]/)
					 {
					 	my $regexp = $1;
					 	$ERR{"$name"} = "Character" . (length $regexp == 1?"":"s") . " [$regexp] " .
					 		(length $regexp == 1?"is":"are") . " not allowed inside this field.", $cgierr++ if $value && $value =~ m#[$regexp]#;

					 	# Remove regular expression from the option.
					 	$opt =~ s/b\[$regexp\]//;
					 }

					if ($opt =~ /r/ && !$value)
					 { $ERR{"$name"} = "Missing Field", $cgierr++; }
					elsif ($opt =~ /d/ && $value && ($value !~ /^[0-9]+$/))
					 { $ERR{"$name"} = "The field $name can only contain digits.", $cgierr++; }
					elsif ($opt =~ /h/ && $value && ($value !~ /^\#[0-9a-zA-Z]+$/ || length($value) != 7))
					 { $ERR{"$name"} = "There is a syntax problem with $name, please remember to write it in hex [#FFDCED]", $cgierr++; }
					elsif ($opt =~ /e/ && $value && &mailcheck($value) == -1)
					 { $ERR{"$name"} = "Incorrect email syntax, please write like 'yourname\@yourhost.com'", $cgierr++; }
					elsif ($opt =~ /u/ && $value && $value !~ m,^http://([^/:]+)(?::(\d+))?(/\S*)?$,)
					 { $ERR{"$name"} = "$name does not have the correct URL syntax.", $cgierr++; }
					elsif ($opt =~ /i/ && $value && $value !~ /(\.gif|\.jpeg|\.jpg)$/i)
					 { $ERR{"$name"} = "$name has incorrect IMAGE syntax, please use a .GIF or .JPG graphic", $cgierr++; }
					elsif ($opt =~ /t/ && !-e $value)
					 { $ERR{"$name"} = "$name ($value) does not exist on the server", $cgierr++; }
					elsif ($opt =~ /w/ && $value && $value =~ /\s/)
					 { $ERR{"$name"} = "Variable $name can not contain any spaces.", $cgierr++; }
  					elsif ($opt =~ /l\[([\d]+)\]\[([\d]+)\]/ && $value)
					 {
					 	$cgierr++, $ERR{"$name"} = "Minimum length for $name is $1, you've only used " . length($value) . " characters" if $1 && length($value) < $1;
					 	$cgierr++, $ERR{"$name"} = "Maximum length for $name is $2, you've used " . length($value) . " characters" if $2 && length($value) > $2;
					 }

					# $ Push all the values of $name to an array of the same name,
					# $ not very pretty but at least it does the trick.
					push @$name, $value if $opt =~ /p/;

					$cgiopt++;
				}

				$INPUT{$name} = $value, $cgicount++;
	 		}

			$FLAGPOST = 1;
  		}

		#  Couple of global variables that I call here to save time.
		$INPUT{'time'} = time;

		1;

  	# $ Read Input ()
	}

#
# $--------------------------------------------------------------------------------------------
#
#  S  U  B  -  F  O  R	M    P	R  I  N  T
#
# $--------------------------------------------------------------------------------------------
#

	sub FormPrint
	{
		my ($tablepref, $tdwidth, $action, $finishform, @type) = @_;
		my ($inputname, $value, $tmp, $errbr);

		$PREF{'ERR'} = "RED" unless $PREF{'ERR'};

		# $ FormPrint can not handle every event I would like it too (I may add it
		# $ in the future but I am trying to keep the code small) so I have the
		# $ option to pause the printing
		unless ($FLAGFORMPRINT)
		{
			$action = "?" . $action if $action;

			print qq!\n\n<FORM METHOD="POST" ACTION="$ENV{'SCRIPT_NAME'}$action">\n! if $action;
			print qq!<CENTER>\n<TABLE $tablepref BGCOLOR="$PREF{'TBCOLOR'}" >\n!;
			print qq!<caption><font size="-1" color="$PREF{ERR}">Error: $ERR{general}</font></caption>! if $ERR{general};
		}

		while (my(@args), @type)
		{

			# $ I had to think about this for a while and the answer actually came
			# $ while I was asleep (thats where I solve most my problems).
			# $
			# $ The problem here was I couldn't use undef because if the value of
			# $ the input field was undef, the whole function was mixed up.  I have
			# $ realised that because my readinput trims leading and trailing spaces,
			# $ the char '\n' can be used to separate each command.

			push(@args, $_) while (@type && ($_ = shift @type) ne "\n");


			$_ = shift @args; # Table command: TEXT, SELECT etc...
			($inputname = $args[1]) =~ s/_(.*?)_([A-Z]+)/$2/; # Trimmed Form Name

			$errbr = "<BR>" unless length($ERR{$inputname}) < 20;
			$ERR{$inputname} =~ s/\s+/&nbsp;/g;

			if (/TEXT\b|PASSWORD/i)
			{
     				$value = (/PASSWORD/i ? "password" : "text");

     				print qq!<TR><TD WIDTH="$tdwidth\%"><FONT SIZE="-1">$args[0] </FONT></TD>
					<TD><INPUT type="$value" name="$args[1]" size="$args[3]" maxlength="$args[4]" value="$args[2]">!;
				print qq!$errbr<FONT COLOR="$PREF{'ERR'}" SIZE="-1">&nbsp;$ERR{$inputname}</FONT>\n! if $ERR{$inputname};
				print qq!</TD></TR>\n\n!;
			}
			elsif (/HEADER/i)
			{
				print qq!<TR BGCOLOR="$PREF{'RESHADE'}">
					<TD><FONT FACE="ARIAL" SIZE="-1"><B>$args[0]&nbsp;</B></TD>
					<TD>&nbsp;</TD></TR>!;
			}
			elsif (/STRING/i)
			{
				# $ Just a simple option to place a string value into the
				# $ form table, there is no error checking here.
				print qq!<TR><TD WIDTH="$tdwidth\%"><FONT SIZE="-1">$args[0]</FONT></TD>
					<TD><FONT SIZE="-1">&nbsp;$args[1] </FONT>\n</TD></TR>\n\n! if ($args[0] and $args[1]);
			}
			elsif (/SELECT/i)
			{
			     	print "<TR><TD><FONT SIZE=-1>" . (shift @args) . "</FONT></TD>\n<TD><SELECT NAME=\"" . (shift @args) . "\">\n";
				$value = shift @args; # Get the next argument which should be the selected value

				while ( $tmp = shift @args )
				{
					print "\t<OPTION VALUE='" . ($_ = shift @args) . "'" .
					      ($_ eq $value ? "SELECTED" : "") . "> $tmp\n";
				}

				print "</SELECT>\n";
				print "<FONT COLOR='$PREF{'ERR'}' SIZE=-1>$ERR{$inputname}</FONT>\n" if $ERR{$inputname};
				print "</TD></TR>\n";
			}
			elsif (/TEXTAREA/i)
			{

				# $ We have two types of textareas, the selling point here
				# $ is we only take notice of TEXTAREAFILE if there is nothing
				# $ being posted. (So we are not constantly rewriting data back)
				if (/TEXTAREA\b/i or $FLAGPOST)
				 {
					($args[2] =~ s/</&lt;/g);
					print qq!<TR><TD><FONT SIZE="-1">$args[0]</FONT></TD>
						<TD><TEXTAREA NAME="$args[1]" COLS="$args[3]" ROWS="$args[4]">$args[2]</TEXTAREA>\n!;
					print qq!$errbr<FONT COLOR="$PREF{'ERR'}" SIZE="-1">$ERR{$inputname}</FONT>\n! if $ERR{$inputname};
					print qq!</TD></TR>\n\n!;
				 }
				else
				 {
					print qq!<TR><TD><FONT SIZE="-1">$args[0]</FONT></TD>
						<TD><TEXTAREA NAME="$args[1]" COLS="$args[3]" ROWS="$args[4]">!;
					&dumpfile($args[2], 1);
					print qq!</TEXTAREA>\n\n</TD></TR>\n\n!;
				 }

			}
			elsif (/HIDDEN/i)
			{
				print qq!<INPUT TYPE="HIDDEN" NAME="$args[0]" VALUE="$args[1]">\n!;

			}
			elsif (/RADIO|CHECKBOX/i)
			{
				$value = (/RADIO/i ? "radio" : "checkbox");

				print "<TR><TD><FONT SIZE=-1>$args[0]</FONT></TD>\n";
				print "<TD><INPUT type=\"$value\" name=\"$args[1]\" value=\"$args[2]\" ", ($args[3] eq $args[2]?"CHECKED":""), ">";
				print "<FONT SIZE=-1>$args[4] </FONT>\n";
				print "</TD></TR>\n";
			}
			else
			{
			 	print "Unknown Argument: '$_'";
			}
		}

		if ($finishform) {
		    $PREF{'FORMCOLSPAN'} = 2 unless $PREF{'FORMCOLSPAN'};
		    print "<TR><TD COLSPAN='$PREF{'FORMCOLSPAN'}' ALIGN=RIGHT BGCOLOR=\"$PREF{'RESHADE'}\"><FONT SIZE=-1><INPUT TYPE=\"submit\" VALUE=\"s u b m i t\">" .
			"</FONT></TD></TR></FORM>\n" if $action;
     		    print "</TABLE></CENTER>\n\n";

     		    $FLAGFORMPRINT = 0; # $ Another form can now be created.
		}

		# $ We know the form has been created, this allows us to include our
		# $ own code into the form or break the code into multiple calls.
		$FLAGFORMPRINT = 1 unless $finishform;

	}

#
# $--------------------------------------------------------------------------------------------
#
#  S  U  B  -  R  E  S	H  A  D  E
#
# $--------------------------------------------------------------------------------------------
#

	# $ This is a good  example of efficiency, I have increased the efficiency
    	# $ of this function by about 1000% ;) if you remember the last version of
    	# $ reshade it was just really stupid, it was late !!! please forgive me !
 	sub reshade
  	{
		my ($shade, $i) = (shift, undef);

		$i = hex(($shade =~ m,#([0-9a-zA-Z]+),)[0]);
		$i += ($i % 256) + 35 >= 256 ? -35 : 35;

		return sprintf("#%6.6X", $i);
	}

#
# $--------------------------------------------------------------------------------------------
#
#  S  U  B  -  W  R  I	T  E  -  P  R  E  F  E	R  E  N  C  E  S
#
# $--------------------------------------------------------------------------------------------
#

	sub write_preferences
	{
		open(PREF,">$PREF{'PREFERENCE'}") || &notify("500 Internal Server Error", "I was not able to write to the \$preference file<BR>chmod it to 666 and try again.", 0);
		print PREF "$PREF{'__COMMENTS__'}";
		foreach (keys(%PREF))
		{
			  printf(PREF "%-13s = %s\n", $_, $PREF{$_}) unless $_ eq '__COMMENTS__';
		}
		close(PREF);
	}

#
# $--------------------------------------------------------------------------------------------
#
#  S  U  B  -  M  A  I	L  C  H  E  C  K
#
# $--------------------------------------------------------------------------------------------
#

	# $ Checks the argument $_[0] for correct email syntax, this little regexp
	# $ doesn't actually check everything but i think its good enough for now ;)

	sub mailcheck
	{
     		if  (($_[0] =~ /[,|\/\\]|(@.*@)|(\.\.)|(\.$)/)
	 		|| ($_[0] !~/^[\w\-\.]+[\%\+]?[\w\-\.]*\@[0-9a-zA-Z\-]+\.[0-9a-zA-Z\-\.]+$/))
		{
			&notify("E-mail address problem !", "Problem with email syntax for $_[1]", 1);
     		}
  	}

#
# $--------------------------------------------------------------------------------------------
#
#  S  U  B  -  C  H  E	C  K	U  S  E  R
#
# $--------------------------------------------------------------------------------------------
#

 	sub check_user
  	{
		return if (($INPUT{'pw'} eq $PREF{'password'}) && ($INPUT{'un'} eq $PREF{'username'}) && ($ENV{'HTTP_REFERER'} =~ /^http:\/\/$ENV{'HTTP_HOST'}$ENV{'SCRIPT_NAME'}/));

		&notify("500 Internal Server Error", "[Internal Server Error]<BR>Security breach I do believe :)", 0);
  	}

#
# $--------------------------------------------------------------------------------------------
#
#  S  U  B  -  M  A  I	L  C  H  E  C  K
#
# $--------------------------------------------------------------------------------------------
#

	# $ Checks the argument $_[0] for correct email syntax, this little regexp
	# $ doesn't actually check everything but i think its good enough for now ;)

	sub mailcheck
	{
     		if  (($_[0] =~ /[,|\/\\]|(@.*@)|(\.\.)|(\.$)/)
	 		|| ($_[0] !~/^[\w\-\.]+[\%\+]?[\w\-\.]*\@[0-9a-zA-Z\-]+\.[0-9a-zA-Z\-\.]+$/))
		{
			&notify("E-mail address problem !", "There is a problem with the e-mail address.", 1);
     		}
  	}

#
# $--------------------------------------------------------------------------------------------
#
#  S  U  B  -  N  F  R	A  M  E
#
# $--------------------------------------------------------------------------------------------
#

 	# $ notifying frame - just a simple subroutine that prints out a table with
	# $ the first argument you pass it embedded in it, saves me a lot of time !

	sub nframe
	{
		print "<BR><CENTER><TABLE CELLSPACING=0 CELLPADDING=9 >\n" .
		      " <TR>\n<TD ALIGN=CENTER BGCOLOR='$PREF{'TBCOLOR'}'><TT>\n" .
		      " $_[0]</TT></TD>\n </TR>\n";
		print "</TABLE></CENTER>\n\n";
	}

#
# $--------------------------------------------------------------------------------------------
#
#  S  U  B  -  M  I  S	S  I  N  G
#
# $--------------------------------------------------------------------------------------------
#

 	# $ subroutine I call when a variable is missing, in the future, I might
	# $ include this in the parsing function above which would save xxx time and
	# $ also let people change my scripts more successfully ?

	sub missing
	{
		&top_html("Missing Field", 0);
		&nframe("Missing Field [$_[0]]<BR> Return to the " .
		   "<a href='$ENV{'HTTP_REFERER'}'> F O R M</a> and try again.");
		&bottom(1);
	}

#
# $--------------------------------------------------------------------------------------------
#
#  S  U  B  -  N  O  T	I  F   Y
#
# $--------------------------------------------------------------------------------------------
#

 	# $ there are 3 arguments passed to this function, 1=TITLE, 2=DISPLAY_TEXT, 3=ADDITIONAL
	# $ the title is self explanatory, the display text is just the text you would like to
	# $ display to the user and the additional is which additional text to add to the nframe

	sub notify
	{
		my ($title, $info, $more, $extra) = (shift, shift, shift, undef);

		$extra = qq!<BR>Return to the <a href="$ENV{'HTTP_REFERER'}"> F O R M</a> and try again.! if $more == 1;
		$extra = qq!<BR>Return to my <A HREF="$PREF{'HOME'}">S	I  T  E</A> and surf on.! if $more == 2;

		&top_html("$title");
		&nframe("<TT>$info $extra</TT>");
		&bottom(1);
	}

#
# $--------------------------------------------------------------------------------------------
#
#  S  U  B  -  I  N  F	O
#
# $--------------------------------------------------------------------------------------------
#

	sub info
	{
		print "<BR><CENTER><TABLE BGCOLOR=\"$PREF{'TBCOLOR'}\" CELLSPACING=0 WIDTH=\"60%\" >\n",
			"<TR BGCOLOR=\"$PREF{'RESHADE'}\">\n",
			"<TD ALIGN=LEFT VALIGN=TOP><FONT SIZE=-1>$_[0] </FONT></TD>\n",
			"</TR>\n",
			"<TR><TD><FONT SIZE=-1>$_[1]</FONT></TD>\n</TR>\n",
		"</TABLE></CENTER>\n";
		&bottom(1) if $_[2];
	}

#
# $--------------------------------------------------------------------------------------------
#
#  S  U  B  -  B  O  T	T  O  M
#
# $--------------------------------------------------------------------------------------------
#

 	# $ hmmmmm ? what does this do I hear you all cry, well I just don't know, I wrote
	# $ it a long time ago and took me about an hour but I don't know what its for ?!?!
	# $ [please note I was being sarcastic, no more emails about what it does] ;)

	sub bottom
	{
		print "</BODY>\n";
		print "</HTML>\n";
		exit 0 if $_[0];
	}

#
# $--------------------------------------------------------------------------------------------
#
#  S  U  B  -  P  R  E	F  E  R  E  N  C  E  S
#
# $--------------------------------------------------------------------------------------------
#

	sub preferences
	{
		my ($no, $prefno);

		open(PREF, $_[0]) || return "$_[0]: Preference file can not be found";
  		for ($no = 1; (<PREF>); $no++)
		{
			if (/^#|^;/)
			{
				$PREF{'__COMMENTS__'} .= $_ if (!$prefno);
			}
			elsif (/^(\w+)\s*=\s?(.*)$/)
			{
				$PREF{$1} = $2;
				$prefno++;
			}
			else
			{
				return "$_[0]:Line $no: incorrect preference structure.";
			}
		}
		close(PREF);

		return ($_[1] == $prefno) ? 1 : "$_[0]: Incorrect number of preferences.";
	}

#
# $--------------------------------------------------------------------------------------------
#
#  S  U  B  -  O  P  E	N  F  I  L  E
#
# $--------------------------------------------------------------------------------------------
#

	sub openf
	{
		my ($FILE, $filename, $type) = (shift, shift, undef);

		$type = ($filename =~ /^(\+|>)/) ? "write to" : "find";

		open $FILE, $filename or &notify('500 Internal Server Error', "I was not able to $type '" . (($filename =~ s/^(\W)+//) ? $filename : $filename) . "'<BR>" .
		"check you've entered the correct location & permissions.<BR><BR>If this is not admin, please let him/her<BR> know about this problem.", 0);

		flock $FILE, 2 if $PREF{'FLOCK'};
	}

#
# $--------------------------------------------------------------------------------------------
#  ===========================================================================================
# $--------------------------------------------------------------------------------------------
#

__DATA__
Preferences
GUESTBOOK NAME: Whatever you write for this value will be placed in the title, the script will automatically append "guestbook" at the end of whatever you write so if you call it "jim's"... the title will say "jim's guestbook".
YOUR URL: The first release didn't have this option on (don't ask me why) but now you can just put the link back to your site/homepage. It is linked to the word [home] on the inter guestbook page.
GIF: This is just the location of any graphic you like to use at the top of the inter guestbook list, it DOES NOT have to be my inter guestbook graphic but please make sure that its the http location of the graphic.<BR><BR><I>TIP: Don't place graphics inside your /cgi-bin directory because sometimes servers treat every file as a CGI file.
BODY TEXT: The main text colour used throughout the scripts, you must remember to write it in hexadecimal format for example; #C0C0FF
PAGE BGCOLOR: The background colour used through out this scripts (will be ignored if you type in a background GIF). Please remember to write it in hexadecimal format for example; #C0C0FF
BACKGROUND GIF: The full http location of any graphic you would like to use in the background of the scripts.  If you don't want to use a background graphic then just leave the field blank.
LINK: The colour of the links used throughout the scripts, try to make it a different colour to the <I>page bgcolor</I> though :) and remember to write it in hexadecimal format for example; #C0C0FF
VISITED LINK: VLINK is the colour of all your visited link links in the cougalinks script.  Please remember to write it in hexadecimal format for example; #C0C0FF
ACTIVE LINK: When someone clicks on a link it changes colour, try it on the links above (keeping hold of the mouse) and you will see it change. This field controls the active link colour. Please remember to write it in hexadecimal format for example; #C0C0FF
TABLE BGCOLOR: Table background colour, this is the colour used behind this text and also makes up the bulk table colour of administration.  I use this colour as you can see here in conjunction with the table row colour above.
TABLE RESHADE: Table reshade colour, this is the other colour I use inside the tables in this script... you can see it being used in the table row above this one.  Please remember to write it in hexadecimal format for example; #C0C0FF
ORDER: The order in which the entries will appear, currently available: Most recent on top and oldest on top.  Each category is sorted in the manner which you select from the drop down menu.
SIGNING AMOUNT: The amount of entries to be stored in the database, I have set the maximum value to 100 because it keeps the data file size down but not only that but the entries which are inside your list remain relatively fresh so your surfers don't wade through old posts.
PER PAGE:A new feature introduced in the 4.5 release, you can now limit the amount of entries displayed per page... for example I have set it to 10 and each page so igb.cgi only displays a maximum of 10 entries, at the bottom there are links to show the next and last 10 entries.
TARGET: Target is the name of the frame the links use helping people using inter guestbook inside frames, for example this variable is used to keep people inside the frame when posting information, add-link, home etc...<BR><BR><I>TIP: If you are not using frames just name the variable _self, alternatively leave it blank and the script will fill in the default value.</I>
URL TARGET: This is the target given to external links inside the script, so you can send people to the link in another browser whilst keeping the link page open.<BR><BR><I>TIP: If you are not using frames just name the variable _self, alternatively leave it blank and the script will fill in the default value.</I>
IGB DATA FILE: The location of the data file which contains all the entries which are submitted to the script.	Please read the README file for more detailed information on how to set it up and what properties to give the file.<BR><BR><I>Example: /usr/home/mysite.com/public_html/cgi-bin/data/igb-data.ais<BR>Example2: data/igb-data.ais</I>
MAIL PROGRAM: This is the location of sendmail on your server, sendmail is a common program used on servers other than windows platforms (although sendmail emulations are available on the web).  This value must be the complete location of the sendmail binary e.g. '<I>/usr/sbin/sendmail</I>' IT MUST be sendmail.<BR><BR>If the program has trouble locating sendmail but you are sure it is correct, look at the top of the admin script for the <i>$CHECK_MAILPROG</i> variable.
LOCK FILES: If you have a guestbook which gets a lot of hits then this MUST be checked, your version of perl MUST have flock() for this to work. At the time of writing this I believe WIN95/98 and possibly WINNT doesn't support this feature but there is only one way to make sure ;)<BR><BR>If your version of perl doesn't support the lock feature cougalinks.cgi will crash (die).
CHECK BIG WORDS: Sometimes people post descriptions as one big word (without any spaces) which makes the <I>how many words</I> invalid, if this is checked, any words over 30 characters are ignored (Don't check if your receiving long charactered information like urls in the description).
DISALLOW HTML: This option enables or disables the ability for ANY information submitted to contain HTML. I keep this checked to keep out banner advertisements but please remember if this is enabled you must increase <I>how many words</I> because each html statement is classed as a word.
HOW MANY WORDS: This depends on how many words you would like the comment to contain. This is to stop people tampering and using massive descriptions (see <I>check big words</I> for other safeguard).<BR><BR><I>TIP: To have no description limit just type <B>0</B> in the [how many words ?] text box.
DISALLOW CERTAIN WORDS: Coupled with <I>confirm links</I> this option attempts to filter bad sites by checking the words in a file (the <I>disallow file</I> igb-disallow.dat) against the words in the description.  If any are found they are told which word is banned and to re-enter their information.
DISALLOW FILE: This file is distributed with inter guestbook and contains all the words (case insensitive) which are not to be permitted through the script.  You can edit the file by hand adding extra words but please make sure each word is separated by a new line.<BR><BR><I>See also: <B>disallow certain words</B></I>

Email Options
NAME: This variable is used when sending emails from anywhere in the script, from signing the guestbook to replying to their message via the administration reply feature.
EMAIL ADDRESS: This variable is used when sending emails from anywhere in the script, from signing the guestbook to replying to their message via the administration reply feature, just enter your current email address.
EMAIL THANKS: If this option is checked then if anybody signs your guestbook an email is sent to them.	The outline of the email which is sent is in the "Mail them what" text box so you can personalise your thanks with ease.
NOTIFY YOU: If this option is checked then you will be informed via email every time someone signs your guestbook, this option is ignored if the signee sends the post as a comment. (You can disable this at any time)
SUBJECT: More variables to customize the whole script to suit your needs, type the subject you want to use in outgoing emails when people post like "Thank you for signing my guestbook"
MAIL THEM WHAT: The text you type into this input box will be sent to the user when s/he signs your guestbook list.  You can personalise it even more by using the key, if you type %n for example, every occurrence of %n will be replaced with the users name.<BR><BR><I>TIP: The box is the right size for sending emails withought them wrapping on to new lines in the email clients.</I>
DEFAULT SUBJECT: In the update guestbook section of administration, if you click on the signatories name, an email screen is displayed and the subject which you write in here is automatically inserted in the reply subject.<BR><BR>The screen which is returned is a new feature which allows you to reply to anyone who signed your guestbook.
USERNAME: This is the username which you use with the password to enter administration, it can contain any sequence of characters but it limited to 8 characters in length.
PASSWORD: The variable is used to prove you are who you say you are (or your a good guesser), if you leave this variable blank in preferences then the old password is retained but if you enter a new one you will be prompted to re-enter administration with your new password.<BR><BR><I>TIP: If you loose your password please read igb-admin.cgi source for information on how to get another.</I>
